<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">

          <div class="col-md-12 py-2 col-sm-12">
            <label for="input-large">Kode Proyek</label>
            <b-form-select
              v-model="filter.code_project"
              :options="projectOptions"
              size="lg"
            ></b-form-select>
          </div>


          <div class="col-md-12 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>
            <b-form-input
                  id="input-large"
                  size="lg"
                  disabled
                  placeholder="Masukkan Nama Proyek"
                  v-model="selectedProject.projectName"
                ></b-form-input>
          </div>

        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click="onShowData">
            <i class="flaticon2-search-1" ></i> Tampilkan
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="d-flex my-3 justify-content-end">
        <vue-excel-xlsx
            :data="data.shopDrawingExt"
            :columns="columns"
            :filename="'ShopDrawingExternal'"
            :sheetname="'sheet1'"
            >
          <button class="btn btn-success btn-md" :disabled="data.shopDrawingExt.length === 0" >
              <i class="fa fa-file-excel"></i>
              Excel
            </button>
        </vue-excel-xlsx>
        
        <button class="btn btn-warning btn-md" @click="onExportPDF" :disabled="data.shopDrawingExt.length === 0"  >
          <i class="fa fa-file-pdf"></i>
           PDF
        </button>
      </div>

      <div class="card-body p-0">
        <div class="table-responsive" ref="contentPDF" id="contentPDF">
          <table
            class="table table-head-custom table-vertical-center table-head-bg table-borderless"
          >
            <thead>
              <tr class="text-left">
                <th style="min-width: 50px" class="pl-7">
                <span class="text-dark-75">No</span>
                </th>
                <th style="min-width: 100px" class="pl-7">
                  <span class="text-dark-75">Numbering</span>
                </th>
                <th style="min-width: 100px">Title</th>
                <th style="min-width: 100px">Stasiun</th>
                <th style="min-width: 100px">Tipe</th>
                <th style="min-width: 100px">Scope</th>
                <th style="min-width: 100px">Status</th>
                <th style="min-width: 100px">Revisi</th>
                <th style="min-width: 100px">Deadline</th>
                <th style="min-width: 101px">PIC Drafter</th>
                <th style="min-width: 101px">Received Date</th>
                <th style="min-width: 101px">Receiver</th>
                <th style="min-width: 101px">Transmittal Number</th>
                <th style="min-width: 101px">Keterangan</th>
              </tr>
            </thead>

            <tbody>
              <template v-for="(item, i) in this.data.shopDrawingExt">
                <tr v-bind:key="i">
                  <td class="pl-0">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.no}}
                  </span>
                </td>
                  <td class="pl-0 ">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.numbering }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.title }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.stasiun }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.type }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.scope }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.status }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.revisi }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.deadline }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.pic_drafter }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.received_date }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.receiver }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.transmittal_number }}
                    </span>
                  </td>

                <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.keterangan }}
                    </span>
                  </td>

    
                </tr>
              </template>
            </tbody>
          </table>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { GET_REPORT_SHOP_DRAWING_EXT } from "@/core/services/store/report-shop-drawing-ext.module";
import { mapGetters } from "vuex";
import { GET_PROJECT_DETAIL } from "@/core/services/store/project.module.js";
import jsPDF from 'jspdf';
import html2canvas from 'html2canvas';


export default {
  name: "ShopDrawingExternal",
  data() {
    return {
      filter: {
        date: null,
        code_project: null,
        code: null
      },
        selectedProject: {
        code:null,
        ownerName: null,
        projectName: null,
        status: null,
        contractNumber: null,
        primpro:null,
        revisi:null
      },
      columns : [
                   {
                        label: "No",
                        field: "no",
                    },
                    {
                        label: "Numbering",
                        field: "numbering",
                    },
                    {
                        label: "Title",
                        field: "title",
                    },
                    {
                        label: "Stasiun",
                        field: "stasiun",
                    },
                    {
                        label: "Type",
                        field: "type",
                    },
                    {
                        label: "Scope",
                        field: "scope",
                    },
                    {
                        label: "Status",
                        field: "status",
                    },
                    {
                        label: "Revisi",
                        field: "revisi",
                    },
                    {
                        label: "Deadline",
                        field: "deadline",
                    },
                     {
                        label: "PIC Drafter",
                        field: "pic_drafter",
                    },
                    {
                        label: "Received Date",
                        field: "received_date",
                    },
                     {
                        label: "Receiver",
                        field: "receiver",
                    },
                    { 
                        label: "Transmittal Number", 
                        field: "transmittal_number", 
                    },
                    { 
                        label: "Keterangan", 
                        field: "keterangan", 
                    },


                ],
      data: {
        shopDrawingExt:[],
      },
        options: {
        project:[
           { value:null, text:null}
        ],
        pic:[
           { value:null, text:null}
        ]
      }
    };
  },
  methods: {

    onPDF(){
      console.log(this.currentReportLettering)
    },

    onShowData(){

        console.log(this.selectedProject.id_project)
        this.$store.dispatch(GET_REPORT_SHOP_DRAWING_EXT,this.selectedProject.id_project).then(() => this.mappingDataShopDrawingExt(this.currentReportShopDrawingExt));

    },

    mappingDataProject(projectList){
        this.options.project = []
        projectList.map(project => this.options.project.push({
            text:project.code + '-' + project.nickname,
            value:project.code
        }))
    },

    mappingDataShopDrawingExt(listDrawing){
        let no = 0;
        this.data.shopDrawingExt = []
        listDrawing.map(drawing => this.data.shopDrawingExt.push({
              no: no = no +1,
              numbering: drawing.numbering,
              title: drawing.title,
              stasiun: drawing.station?.name,
              type:drawing.type?.name,
              scope:drawing.scope?.name,
              status:drawing.last_status?.code,
              revisi:drawing.revision_version,
              deadline:drawing.deadline,
              pic_drafter:drawing.drafter_pic?.name,
              received_date:drawing.date_receive,
              receiver:drawing.receiver,
              transmittal_number:drawing.transmittal_number,
              keterangan:drawing.shd_comment
        }))
    },



    onExportPDF(){
      window.html2canvas = html2canvas;
       var doc = new jsPDF("l","pt","A3");
       doc.setFontSize(100)
       doc.html(document.querySelector("#contentPDF"),{
         callback:function(pdf){
     
           pdf.save("ShopDrawingExternal.pdf");
         }
       },true)

       console.log("pdfdoc",doc)
  
    }

  },
  async mounted() {
    await this.$store.dispatch(SET_BREADCRUMB, [{ title: "Report Shop Drawing External" }]);
    await this.$store.dispatch(GET_PROJECT_DETAIL, "design" ).then(
        () => this.mappingDataProject(this.currentProjectDetails)
    );
    
  },
  computed: {
    ...mapGetters(["currentReportShopDrawingExt","currentPics","currentProjectDetails"]),
    projectOptions(){
          var result =  [{ value: null, text: "Pilih Proyek" }];
              if(this.currentProjectDetails != undefined){
              this.currentProjectDetails.map(project => {
                result.push( {
                  value: project.code,
                  text: project.code + "-" + project.nickname
                });
              });
          }   
        return result;
      },

      currentProjectCode() { 
        return this.filter.code_project; 
      }

  },
   watch: {
    currentProjectCode(value) {
      if (!value) {
        Object.assign(this.selectedProject, {
          id_project:null,
          ownerName: null,
          projectName: null,
          status: null,
          contractNumber: null,
          revisi:null,
          primpro:null
        });


        return;
      }

      var resultProject = this.currentProjectDetails.filter(c=>c.code === value )

      Object.assign(this.selectedProject, {
        id_project: resultProject[0].code,
        ownerName: resultProject[0].owner,
        projectName: resultProject[0].name,
        status: resultProject[0].status,
        contractNumber: resultProject[0].contract_no,
        primpro : resultProject[0].leader,
        revisi:resultProject[0].site_document_revision
      });

      //this.getDocumentSiteByProject(value);

    }
  },
};
</script>

<style></style>
